libzypp: zypp::sat Namespace Reference

libzypp 17.38.6

zypp::sat Namespace Reference

Libsolv interface More...

## Namespaces
namespace | detail
namespace | solvitermixin_detail

## Classes
class | FileConflicts
| Libsolv queue representing file conflicts. More...
class | LocaleSupport
| Convenience methods to manage support for a specific Locale. More...
class | LookupAttr
| Lightweight attribute value lookup. More...
class | LookupRepoAttr
| Lightweight repository attribute value lookup. More...
class | ArrayAttr
| LookupAttr::TransformIterator based container to retrieve list attributes. More...
class | Map
| Libsolv (bit)Map wrapper. More...
class | Pool
| Global sat-pool. More...
class | Queue
| Libsolv Id queue wrapper. More...
class | Solvable
| A Solvable object within the sat Pool. More...
struct | asSolvable
| To Solvable transform functor. More...
class | SolvableSet
| Solvable set wrapper to allow adding additional convenience iterators. More...
class | SolvableType
| Base class for creating Solvable based types. More...
class | SolvIterMixin
| Base class providing common iterator types based on a Solvable iterator. More...
class | Transaction
| Libsolv transaction wrapper. More...
class | WhatObsoletes
| Container of installed Solvable which would be obsoleted by the Solvable passed to the ctor. More...
class | WhatProvides
| Container of Solvable providing a Capability (read only). More...
class | AllPTFs
| Container of packages providing ptf(). More...
class | SolvAttr
| Solvable attribute keys. More...

## Typedefs
using | SolvableQueue = Queue
| Queue with Solvable ids.
using | StringQueue = Queue
| Queue with String ids.

## Functions
std::ostream & | operator<< (std::ostream &str, const FileConflicts &obj) ZYPP_API
| relates: FileConflicts Stream output
std::ostream & | operator<< (std::ostream &str, const FileConflicts::Conflict &obj) ZYPP_API
| relates: FileConflicts::Conflict Stream output
std::ostream & | dumpAsXmlOn (std::ostream &str, const FileConflicts &obj) ZYPP_API
| relates: FileConflicts XML output
std::ostream & | dumpAsXmlOn (std::ostream &str, const FileConflicts::Conflict &obj) ZYPP_API
| relates: FileConflicts::Conflict XML output
bool | operator== (const FileConflicts &lhs, const FileConflicts &rhs)
| relates: FileConflicts
bool | operator!= (const FileConflicts &lhs, const FileConflicts &rhs)
| relates: FileConflicts
std::ostream & | operator<< (std::ostream &str, const LocaleSupport &obj)
| relates: LocaleSupport Stream output
std::ostream & | dumpOn (std::ostream &str, const LocaleSupport &obj)
| relates: LocaleSupport More verbose stream output including dependencies
bool | operator== (const LocaleSupport &lhs, const LocaleSupport &rhs)
| relates: LocaleSupport
bool | operator!= (const LocaleSupport &lhs, const LocaleSupport &rhs)
| relates: LocaleSupport
bool | operator< (const LocaleSupport &lhs, const LocaleSupport &rhs)
| relates: LocaleSupport
std::ostream & | operator<< (std::ostream &str, const LookupAttr &obj) ZYPP_API
| relates: LookupAttr Stream output.
std::ostream & | dumpOn (std::ostream &str, const LookupAttr &obj) ZYPP_API
| relates: LookupAttr Verbose stream output including the query result.
std::ostream & | operator<< (std::ostream &str, const LookupAttr::iterator &obj) ZYPP_API
| relates: zypp::sat::LookupAttr::iterator Stream output.
template<class TResult, class TAttr>
std::ostream & | operator<< (std::ostream &str, const ArrayAttr< TResult, TAttr > &obj)
| relates: zypp::sat::LookupAttr::iterator Stream output.
bool | operator== (const Map &lhs, const Map &rhs) ZYPP_API
| relates: Map
std::ostream & | operator<< (std::ostream &str, const Map &obj)
| relates: Map Stream output
bool | operator!= (const Map &lhs, const Map &rhs)
| relates: Map
std::ostream & | operator<< (std::ostream &str, const Pool &obj) ZYPP_API
| relates: Pool Stream output
void | updateSolvFileIndex (const Pathname &solvfile_r)
| Create solv file content digest for zypper bash completion.
bool | operator== (const Pool &lhs, const Pool &rhs)
| relates: Pool
bool | operator!= (const Pool &lhs, const Pool &rhs)
| relates: Pool
std::ostream & | operator<< (std::ostream &str, const Queue &obj) ZYPP_API
| relates: Queue Stream output
std::ostream & | dumpOn (std::ostream &str, const Queue &obj) ZYPP_API
| relates: Queue Stream output assuming a Solvable queue.
bool | operator== (const Queue &lhs, const Queue &rhs) ZYPP_API
| relates: Queue
bool | operator!= (const Queue &lhs, const Queue &rhs)
| relates: Queue
std::ostream & | operator<< (std::ostream &str, const Solvable &obj) ZYPP_API
| relates: Solvable Stream output
std::ostream & | dumpOn (std::ostream &str, const Solvable &obj) ZYPP_API
| relates: Solvable More verbose stream output including dependencies
std::ostream & | dumpAsXmlOn (std::ostream &str, const Solvable &obj) ZYPP_API
| relates: Solvable XML output
bool | operator== (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable
bool | operator!= (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable
bool | operator< (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable
template<class TRes>
bool | isKind (const Solvable &solvable_r)
| relates: Solvable Test whether a Solvable is of a certain Kind.
bool | identical (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Test for same content.
bool | sameNVRA (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Test for same name version release and arch.
int | compareByN (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Compare according to kind and name.
int | compareByNVR (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Compare according to kind, name and edition.
int | compareByNVRA (const Solvable &lhs, const Solvable &rhs)
| relates: Solvable Compare according to kind, name, edition and arch.
std::ostream & | operator<< (std::ostream &str, const SolvableSet &obj)
| relates: SolvableSet Stream output
std::ostream & | operator<< (std::ostream &str, const SolvableSpec::Impl &obj)
| relates: SolvableSpec::Impl Stream output
std::ostream & | operator<< (std::ostream &str, const SolvableSpec &obj)
| relates: SolvableSpec Stream output
| SolvableSpec ()
| ~SolvableSpec ()
| Dtor.
| SolvableSpec (const SolvableSpec &)=default
| SolvableSpec (SolvableSpec &&) noexcept=default
SolvableSpec & | operator= (const SolvableSpec &)=default
SolvableSpec & | operator= (SolvableSpec &&) noexcept=default
void | addIdent (IdString ident_r)
| Add all sat::Solvable with this ident_r.
void | addProvides (Capability provides_r)
| A all sat::Solvable matching this provides_r.
bool | addIdenticalInstalledToo () const
| Extend the provides set to include idential installed items as well.
void | addIdenticalInstalledToo (bool yesno_r)
void | parseFrom (const InputStream &istr_r)
| Parse and add spec from a string (IDENT or provides:CAPABILITY`).
template<class TIterator>
void | parseFrom (TIterator begin, TIterator end)
| Parse and add specs from iterator range.
void | splitParseFrom (const C_Str &multispec_r)
| Convenience using str::splitEscaped(", \t") to parse multiple specs from one line.
bool | contains (const sat::Solvable &solv_r) const
| Test whether solv_r matches the spec.
template<class Derived>
bool | contains (const SolvableType< Derived > &solv_r) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | dirty () const
| Whether the cache is needed and dirty.
void | setDirty () const
| Explicitly flag the cache as dirty, so it will be rebuilt on the next request.
bool | empty () const
| Whether neither idents nor provides are set.
bool | containsIdent (const IdString &ident_r) const
| Whether ident_r has been added to the specs (mainly for parser tests).
bool | containsProvides (const Capability &provides_r) const
| Whether provides_r has been added to the sepcs (mainly for parser tests).
template<class Derived>
std::ostream & | operator<< (std::ostream &str, const SolvableType< Derived > &obj)
| relates: SolvableType Stream output
template<class Derived>
std::ostream & | dumpOn (std::ostream &str, const SolvableType< Derived > &obj)
| relates: SolvableType More verbose stream output including dependencies
template<class LDerived, class RDerived>
bool | operator== (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| relates: SolvableType Equal
template<class Derived>
bool | operator== (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | operator== (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class LDerived, class RDerived>
bool | operator!= (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| relates: SolvableType NotEqual
template<class Derived>
bool | operator!= (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | operator!= (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class LDerived, class RDerived>
bool | operator< (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| relates: SolvableType Less
template<class Derived>
bool | operator< (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | operator< (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class TRes, class Derived>
bool | isKind (const SolvableType< Derived > &solvable_r)
| relates: SolvableType Test whether the Solvable is of a certain ResKind.
template<class LDerived, class RDerived>
bool | identical (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| relates: SolvableType Test for same content.
template<class Derived>
bool | identical (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | identical (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class LDerived, class RDerived>
bool | sameNVRA (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| relates: SolvableType Test for same name version release and arch.
template<class Derived>
bool | sameNVRA (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | sameNVRA (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class LDerived, class RDerived>
int | compareByN (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| relates: SolvableType Compare according to kind and name.
template<class Derived>
bool | compareByN (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByN (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class LDerived, class RDerived>
int | compareByNVR (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| relates: SolvableType Compare according to kind, name and edition.
template<class Derived>
bool | compareByNVR (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByNVR (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class LDerived, class RDerived>
int | compareByNVRA (const SolvableType< LDerived > &lhs, const SolvableType< RDerived > &rhs)
| relates: SolvableType Compare according to kind, name, edition and arch.
template<class Derived>
bool | compareByNVRA (const SolvableType< Derived > &lhs, const Solvable &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class Derived>
bool | compareByNVRA (const Solvable &lhs, const SolvableType< Derived > &rhs)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
std::ostream & | operator<< (std::ostream &str, const Transaction::Impl &obj)
| relates: Transaction::Impl Stream output
std::ostream & | operator<< (std::ostream &str, const Transaction &obj)
| relates: Transaction Stream output
std::ostream & | dumpOn (std::ostream &str, const Transaction &obj)
| relates: Transaction Verbose stream output
bool | operator== (const Transaction &lhs, const Transaction &rhs)
| relates: Transaction
std::ostream & | operator<< (std::ostream &str, const Transaction::Step &obj)
| relates: Transaction::Step Stream output
std::ostream & | operator<< (std::ostream &str, Transaction::StepType obj) ZYPP_API
| relates: Transaction::StepType Stream output
std::ostream & | operator<< (std::ostream &str, Transaction::StepStage obj) ZYPP_API
| relates: Transaction::StepStage Stream output
| ZYPP_DECLARE_OPERATORS_FOR_FLAGS (Transaction::StepStages)
bool | operator!= (const Transaction &lhs, const Transaction &rhs)
| relates: Transaction
std::ostream & | operator<< (std::ostream &str, const WhatObsoletes &obj)
| relates: WhatObsoletes Stream output
std::ostream & | operator<< (std::ostream &str, const WhatProvides &obj)
| relates: WhatProvides Stream output
static const SolvableIdType | noSolvableId (0)
| Id to denote Solvable::noSolvable.
Helpers and forward declarations from LookupAttrTools.h
template<>
std::string | LookupAttr::iterator::asType< std::string > () const

## Variables
RWCOW_pointer< Impl > | _pimpl
| Implementation class.
bool | obsoleteUsesProvides = false

## Detailed Description

Libsolv interface

## Typedef Documentation

## ◆ SolvableQueue

using zypp::sat::SolvableQueue = Queue

Queue with Solvable ids.

Definition at line 27 of file Queue.h.

## ◆ StringQueue

using zypp::sat::StringQueue = Queue

Queue with String ids.

Definition at line 28 of file Queue.h.

## Function Documentation

## ◆ operator<<() [1/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const FileConflicts & | obj )

relates: FileConflicts Stream output

Definition at line 109 of file FileConflicts.cc.

## ◆ operator<<() [2/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const FileConflicts::Conflict & | obj )

relates: FileConflicts::Conflict Stream output

Definition at line 112 of file FileConflicts.cc.

## ◆ dumpAsXmlOn() [1/3]

std::ostream & zypp::sat::dumpAsXmlOn | ( | std::ostream & | str,
|  | const FileConflicts & | obj )

relates: FileConflicts XML output

Definition at line 132 of file FileConflicts.cc.

## ◆ dumpAsXmlOn() [2/3]

std::ostream & zypp::sat::dumpAsXmlOn | ( | std::ostream & | str,
|  | const FileConflicts::Conflict & | obj )

relates: FileConflicts::Conflict XML output

Definition at line 156 of file FileConflicts.cc.

## ◆ operator==() [1/10]

bool zypp::sat::operator== | ( | const FileConflicts & | lhs,
|  | const FileConflicts & | rhs )
| inline

relates: FileConflicts

Definition at line 85 of file FileConflicts.h.

## ◆ operator!=() [1/10]

bool zypp::sat::operator!= | ( | const FileConflicts & | lhs,
|  | const FileConflicts & | rhs )
| inline

relates: FileConflicts

Definition at line 89 of file FileConflicts.h.

## ◆ operator<<() [3/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const LocaleSupport & | obj )

relates: LocaleSupport Stream output

Definition at line 31 of file LocaleSupport.cc.

## ◆ dumpOn() [1/6]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const LocaleSupport & | obj )

relates: LocaleSupport More verbose stream output including dependencies

Definition at line 41 of file LocaleSupport.cc.

## ◆ operator==() [2/10]

bool zypp::sat::operator== | ( | const LocaleSupport & | lhs,
|  | const LocaleSupport & | rhs )
| inline

relates: LocaleSupport

Definition at line 112 of file LocaleSupport.h.

## ◆ operator!=() [2/10]

bool zypp::sat::operator!= | ( | const LocaleSupport & | lhs,
|  | const LocaleSupport & | rhs )
| inline

relates: LocaleSupport

Definition at line 116 of file LocaleSupport.h.

## ◆ operator<() [1/5]

bool zypp::sat::operator< | ( | const LocaleSupport & | lhs,
|  | const LocaleSupport & | rhs )
| inline

relates: LocaleSupport

Definition at line 120 of file LocaleSupport.h.

## ◆ operator<<() [4/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const LookupAttr & | obj )

relates: LookupAttr Stream output.

Definition at line 256 of file LookupAttr.cc.

## ◆ dumpOn() [2/6]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const LookupAttr & | obj )

relates: LookupAttr Verbose stream output including the query result.

Definition at line 273 of file LookupAttr.cc.

## ◆ operator<<() [5/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const LookupAttr::iterator & | obj )

relates: zypp::sat::LookupAttr::iterator Stream output.

Definition at line 782 of file LookupAttr.cc.

## ◆ LookupAttr::iterator::asType< std::string >()

template<>

std::string zypp::sat::LookupAttr::iterator::asType< std::string > | ( |  | ) | const
| inline

Definition at line 594 of file LookupAttr.h.

## ◆ operator<<() [6/21]

template<class TResult, class TAttr>

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const ArrayAttr< TResult, TAttr > & | obj )
| inline

relates: zypp::sat::LookupAttr::iterator Stream output.

Definition at line 216 of file LookupAttrTools.h.

## ◆ operator==() [3/10]

bool zypp::sat::operator== | ( | const Map & | lhs,
|  | const Map & | rhs )

relates: Map

Definition at line 125 of file Map.cc.

## ◆ operator<<() [7/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Map & | obj )
| inline

relates: Map Stream output

Definition at line 116 of file Map.h.

## ◆ operator!=() [3/10]

bool zypp::sat::operator!= | ( | const Map & | lhs,
|  | const Map & | rhs )
| inline

relates: Map

Definition at line 123 of file Map.h.

## ◆ operator<<() [8/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Pool & | obj )

relates: Pool Stream output

Definition at line 274 of file Pool.cc.

## ◆ updateSolvFileIndex()

void zypp::sat::updateSolvFileIndex | ( | const Pathname & | solvfile_r | ) |

Create solv file content digest for zypper bash completion.

Definition at line 286 of file Pool.cc.

## ◆ operator==() [4/10]

bool zypp::sat::operator== | ( | const Pool & | lhs,
|  | const Pool & | rhs )
| inline

relates: Pool

Definition at line 294 of file Pool.h.

## ◆ operator!=() [4/10]

bool zypp::sat::operator!= | ( | const Pool & | lhs,
|  | const Pool & | rhs )
| inline

relates: Pool

Definition at line 298 of file Pool.h.

## ◆ operator<<() [9/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Queue & | obj )

relates: Queue Stream output

Definition at line 121 of file Queue.cc.

## ◆ dumpOn() [3/6]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const Queue & | obj )

relates: Queue Stream output assuming a Solvable queue.

Definition at line 124 of file Queue.cc.

## ◆ operator==() [5/10]

bool zypp::sat::operator== | ( | const Queue & | lhs,
|  | const Queue & | rhs )

relates: Queue

Definition at line 136 of file Queue.cc.

## ◆ operator!=() [5/10]

bool zypp::sat::operator!= | ( | const Queue & | lhs,
|  | const Queue & | rhs )
| inline

relates: Queue

Definition at line 128 of file Queue.h.

## ◆ operator<<() [10/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Solvable & | obj )

relates: Solvable Stream output

Definition at line 797 of file Solvable.cc.

## ◆ dumpOn() [4/6]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const Solvable & | obj )

relates: Solvable More verbose stream output including dependencies

Definition at line 808 of file Solvable.cc.

## ◆ dumpAsXmlOn() [3/3]

std::ostream & zypp::sat::dumpAsXmlOn | ( | std::ostream & | str,
|  | const Solvable & | obj )

relates: Solvable XML output

Definition at line 828 of file Solvable.cc.

## ◆ operator==() [6/10]

bool zypp::sat::operator== | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable

Definition at line 481 of file Solvable.h.

## ◆ operator!=() [6/10]

bool zypp::sat::operator!= | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable

Definition at line 485 of file Solvable.h.

## ◆ operator<() [2/5]

bool zypp::sat::operator< | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable

Definition at line 489 of file Solvable.h.

## ◆ isKind() [1/2]

template<class TRes>

bool zypp::sat::isKind | ( | const Solvable & | solvable_r | ) |
| inline

relates: Solvable Test whether a Solvable is of a certain Kind.

Definition at line 494 of file Solvable.h.

## ◆ identical() [1/4]

bool zypp::sat::identical | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Test for same content.

Definition at line 498 of file Solvable.h.

## ◆ sameNVRA() [1/4]

bool zypp::sat::sameNVRA | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Test for same name version release and arch.

Definition at line 502 of file Solvable.h.

## ◆ compareByN() [1/4]

int zypp::sat::compareByN | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Compare according to kind and name.

Definition at line 507 of file Solvable.h.

## ◆ compareByNVR() [1/4]

int zypp::sat::compareByNVR | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Compare according to kind, name and edition.

Definition at line 519 of file Solvable.h.

## ◆ compareByNVRA() [1/4]

int zypp::sat::compareByNVRA | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| inline

relates: Solvable Compare according to kind, name, edition and arch.

Definition at line 528 of file Solvable.h.

## ◆ operator<<() [11/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const SolvableSet & | obj )

relates: SolvableSet Stream output

Definition at line 31 of file SolvableSet.cc.

## ◆ operator<<() [12/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const SolvableSpec::Impl & | obj )
| inline

relates: SolvableSpec::Impl Stream output

Definition at line 130 of file SolvableSpec.cc.

## ◆ operator<<() [13/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const SolvableSpec & | obj )

relates: SolvableSpec Stream output

Definition at line 201 of file SolvableSpec.cc.

## ◆ SolvableSpec() [1/3]

zypp::sat::SolvableSpec | ( |  | ) |

## ◆ ~SolvableSpec()

zypp::sat::~SolvableSpec | ( |  | ) |

Dtor.

## ◆ SolvableSpec() [2/3]

zypp::sat::SolvableSpec | ( | const SolvableSpec & |  | ) |
| default

## ◆ SolvableSpec() [3/3]

zypp::sat::SolvableSpec | ( | SolvableSpec && |  | ) |
| defaultnoexcept

## ◆ operator=() [1/2]

SolvableSpec & zypp::sat::operator= | ( | const SolvableSpec & |  | ) |
| default

## ◆ operator=() [2/2]

SolvableSpec & zypp::sat::operator= | ( | SolvableSpec && |  | ) |
| defaultnoexcept

## ◆ addIdent()

void zypp::sat::addIdent | ( | IdString | ident_r | ) |

Add all sat::Solvable with this ident_r.

## ◆ addProvides()

void zypp::sat::addProvides | ( | Capability | provides_r | ) |

A all sat::Solvable matching this provides_r.

## ◆ addIdenticalInstalledToo() [1/2]

bool zypp::sat::addIdenticalInstalledToo | ( |  | ) | const

Extend the provides set to include idential installed items as well.

Hack for retracted packages, where the indicator provides is injected into the available items, but is not present in the installed items.

## ◆ addIdenticalInstalledToo() [2/2]

void zypp::sat::addIdenticalInstalledToo | ( | bool | yesno_r | ) |

## ◆ parseFrom() [1/2]

void zypp::sat::parseFrom | ( | const InputStream & | istr_r | ) |

Parse and add spec from a string (IDENT or provides:CAPABILITY`).

*/ void parse( const C_Str & spec_r );

/** Parse file istr_r and add its specs (one per line, #-comments).

## ◆ parseFrom() [2/2]

template<class TIterator>

void zypp::sat::parseFrom | ( | TIterator | begin,
|  | TIterator | end )

Parse and add specs from iterator range.

Definition at line 81 of file SolvableSpec.h.

## ◆ splitParseFrom()

void zypp::sat::splitParseFrom | ( | const C_Str & | multispec_r | ) |

Convenience using str::splitEscaped(", \t") to parse multiple specs from one line.

## ◆ contains() [1/2]

bool zypp::sat::contains | ( | const sat::Solvable & | solv_r | ) | const

Test whether solv_r matches the spec.

(Re-)builds the WhatProvides cache on demand.

Note
  Does not match srcpackage: per default.

## ◆ contains() [2/2]

template<class Derived>

bool zypp::sat::contains | ( | const SolvableType< Derived > & | solv_r | ) | const

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 96 of file SolvableSpec.h.

## ◆ dirty()

bool zypp::sat::dirty | ( |  | ) | const

Whether the cache is needed and dirty.

## ◆ setDirty()

void zypp::sat::setDirty | ( |  | ) | const

Explicitly flag the cache as dirty, so it will be rebuilt on the next request.

To be called if the ResPool content has changed. Intentionally const as this does not change the set of spects (though the set of matches might change).

Note
  This has no effect if no cache is needed (i.e. no provides: are used).

## ◆ empty()

bool zypp::sat::empty | ( |  | ) | const

Whether neither idents nor provides are set.

## ◆ containsIdent()

bool zypp::sat::containsIdent | ( | const IdString & | ident_r | ) | const

Whether ident_r has been added to the specs (mainly for parser tests).

## ◆ containsProvides()

bool zypp::sat::containsProvides | ( | const Capability & | provides_r | ) | const

Whether provides_r has been added to the sepcs (mainly for parser tests).

## ◆ operator<<() [14/21]

template<class Derived>

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const SolvableType< Derived > & | obj )
| inline

relates: SolvableType Stream output

Definition at line 179 of file SolvableType.h.

## ◆ dumpOn() [5/6]

template<class Derived>

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const SolvableType< Derived > & | obj )
| inline

relates: SolvableType More verbose stream output including dependencies

Definition at line 184 of file SolvableType.h.

## ◆ operator==() [7/10]

template<class LDerived, class RDerived>

bool zypp::sat::operator== | ( | const SolvableType< LDerived > & | lhs,
|  | const SolvableType< RDerived > & | rhs )
| inline

relates: SolvableType Equal

Definition at line 189 of file SolvableType.h.

## ◆ operator==() [8/10]

template<class Derived>

bool zypp::sat::operator== | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 193 of file SolvableType.h.

## ◆ operator==() [9/10]

template<class Derived>

bool zypp::sat::operator== | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 197 of file SolvableType.h.

## ◆ operator!=() [7/10]

template<class LDerived, class RDerived>

bool zypp::sat::operator!= | ( | const SolvableType< LDerived > & | lhs,
|  | const SolvableType< RDerived > & | rhs )
| inline

relates: SolvableType NotEqual

Definition at line 202 of file SolvableType.h.

## ◆ operator!=() [8/10]

template<class Derived>

bool zypp::sat::operator!= | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 206 of file SolvableType.h.

## ◆ operator!=() [9/10]

template<class Derived>

bool zypp::sat::operator!= | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 210 of file SolvableType.h.

## ◆ operator<() [3/5]

template<class LDerived, class RDerived>

bool zypp::sat::operator< | ( | const SolvableType< LDerived > & | lhs,
|  | const SolvableType< RDerived > & | rhs )
| inline

relates: SolvableType Less

Definition at line 215 of file SolvableType.h.

## ◆ operator<() [4/5]

template<class Derived>

bool zypp::sat::operator< | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 219 of file SolvableType.h.

## ◆ operator<() [5/5]

template<class Derived>

bool zypp::sat::operator< | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 223 of file SolvableType.h.

## ◆ isKind() [2/2]

template<class TRes, class Derived>

bool zypp::sat::isKind | ( | const SolvableType< Derived > & | solvable_r | ) |
| inline

relates: SolvableType Test whether the Solvable is of a certain ResKind.

Definition at line 228 of file SolvableType.h.

## ◆ identical() [2/4]

template<class LDerived, class RDerived>

bool zypp::sat::identical | ( | const SolvableType< LDerived > & | lhs,
|  | const SolvableType< RDerived > & | rhs )
| inline

relates: SolvableType Test for same content.

Definition at line 233 of file SolvableType.h.

## ◆ identical() [3/4]

template<class Derived>

bool zypp::sat::identical | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 237 of file SolvableType.h.

## ◆ identical() [4/4]

template<class Derived>

bool zypp::sat::identical | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 241 of file SolvableType.h.

## ◆ sameNVRA() [2/4]

template<class LDerived, class RDerived>

bool zypp::sat::sameNVRA | ( | const SolvableType< LDerived > & | lhs,
|  | const SolvableType< RDerived > & | rhs )
| inline

relates: SolvableType Test for same name version release and arch.

Definition at line 246 of file SolvableType.h.

## ◆ sameNVRA() [3/4]

template<class Derived>

bool zypp::sat::sameNVRA | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 250 of file SolvableType.h.

## ◆ sameNVRA() [4/4]

template<class Derived>

bool zypp::sat::sameNVRA | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 254 of file SolvableType.h.

## ◆ compareByN() [2/4]

template<class LDerived, class RDerived>

int zypp::sat::compareByN | ( | const SolvableType< LDerived > & | lhs,
|  | const SolvableType< RDerived > & | rhs )
| inline

relates: SolvableType Compare according to kind and name.

Definition at line 260 of file SolvableType.h.

## ◆ compareByN() [3/4]

template<class Derived>

bool zypp::sat::compareByN | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 264 of file SolvableType.h.

## ◆ compareByN() [4/4]

template<class Derived>

bool zypp::sat::compareByN | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 268 of file SolvableType.h.

## ◆ compareByNVR() [2/4]

template<class LDerived, class RDerived>

int zypp::sat::compareByNVR | ( | const SolvableType< LDerived > & | lhs,
|  | const SolvableType< RDerived > & | rhs )
| inline

relates: SolvableType Compare according to kind, name and edition.

Definition at line 274 of file SolvableType.h.

## ◆ compareByNVR() [3/4]

template<class Derived>

bool zypp::sat::compareByNVR | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 278 of file SolvableType.h.

## ◆ compareByNVR() [4/4]

template<class Derived>

bool zypp::sat::compareByNVR | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 282 of file SolvableType.h.

## ◆ compareByNVRA() [2/4]

template<class LDerived, class RDerived>

int zypp::sat::compareByNVRA | ( | const SolvableType< LDerived > & | lhs,
|  | const SolvableType< RDerived > & | rhs )
| inline

relates: SolvableType Compare according to kind, name, edition and arch.

Definition at line 287 of file SolvableType.h.

## ◆ compareByNVRA() [3/4]

template<class Derived>

bool zypp::sat::compareByNVRA | ( | const SolvableType< Derived > & | lhs,
|  | const Solvable & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 291 of file SolvableType.h.

## ◆ compareByNVRA() [4/4]

template<class Derived>

bool zypp::sat::compareByNVRA | ( | const Solvable & | lhs,
|  | const SolvableType< Derived > & | rhs )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 295 of file SolvableType.h.

## ◆ operator<<() [15/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Transaction::Impl & | obj )
| inline

relates: Transaction::Impl Stream output

Definition at line 305 of file Transaction.cc.

## ◆ operator<<() [16/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Transaction & | obj )

relates: Transaction Stream output

Definition at line 366 of file Transaction.cc.

## ◆ dumpOn() [6/6]

std::ostream & zypp::sat::dumpOn | ( | std::ostream & | str,
|  | const Transaction & | obj )

relates: Transaction Verbose stream output

Definition at line 369 of file Transaction.cc.

## ◆ operator==() [10/10]

bool zypp::sat::operator== | ( | const Transaction & | lhs,
|  | const Transaction & | rhs )

relates: Transaction

Definition at line 378 of file Transaction.cc.

## ◆ operator<<() [17/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const Transaction::Step & | obj )

relates: Transaction::Step Stream output

Definition at line 408 of file Transaction.cc.

## ◆ operator<<() [18/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | Transaction::StepType | obj )

relates: Transaction::StepType Stream output

Definition at line 418 of file Transaction.cc.

## ◆ operator<<() [19/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | Transaction::StepStage | obj )

relates: Transaction::StepStage Stream output

Definition at line 432 of file Transaction.cc.

## ◆ ZYPP_DECLARE_OPERATORS_FOR_FLAGS()

zypp::sat::ZYPP_DECLARE_OPERATORS_FOR_FLAGS | ( | Transaction::StepStages |  | ) |

## ◆ operator!=() [10/10]

bool zypp::sat::operator!= | ( | const Transaction & | lhs,
|  | const Transaction & | rhs )
| inline

relates: Transaction

Definition at line 204 of file Transaction.h.

## ◆ operator<<() [20/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const WhatObsoletes & | obj )

relates: WhatObsoletes Stream output

Definition at line 166 of file WhatObsoletes.cc.

## ◆ operator<<() [21/21]

std::ostream & zypp::sat::operator<< | ( | std::ostream & | str,
|  | const WhatProvides & | obj )

relates: WhatProvides Stream output

Definition at line 162 of file WhatProvides.cc.

## ◆ noSolvableId()

const SolvableIdType zypp::sat::detail::noSolvableId | ( | 0 |  | ) |
| static

Id to denote Solvable::noSolvable.

## Variable Documentation

## ◆ _pimpl

RWCOW_pointer<Impl> zypp::sat::_pimpl
| private

Implementation class.

Pointer to implementation.

Definition at line 122 of file SolvableSpec.h.

## ◆ obsoleteUsesProvides

bool zypp::sat::obsoleteUsesProvides = false

Definition at line 34 of file WhatObsoletes.cc.